import static com.kms.katalon.core.testobject.ObjectRepository.findTestObject

import org.openqa.selenium.OutputType
import org.openqa.selenium.io.FileHandler

import com.kms.katalon.core.configuration.RunConfiguration
import com.kms.katalon.core.util.KeywordUtil
import com.kms.katalon.core.webui.common.WebUiCommonHelper
import com.kms.katalon.core.webui.keyword.WebUiBuiltInKeywords as WebUI

import cucumber.api.java.en.Given
import cucumber.api.java.en.Then
import cucumber.api.java.en.When
import net.sourceforge.tess4j.Tesseract

class CaptchaTest {

	@Given("Navigate to Website (.*)")
	def navigate_to_website(String url) {
		WebUI.openBrowser(url);
	}

	@When("Capture the Captcha image")
	def capture_the_captcha_image() {
		File captchaImage = WebUiCommonHelper.findWebElement(findTestObject('Object Repository/captcha_text'), 10).getScreenshotAs(OutputType.FILE);
		String imagePath = RunConfiguration.getProjectDir() + "/Captcha/captcha.png";
		FileHandler.copy(captchaImage, new File(imagePath));
	}

	@Then("Enter the Captcha")
	def enter_the_captcha() {
		Tesseract instance = new Tesseract();
		instance.setDatapath(RunConfiguration.getProjectDir() + "/tessdata");
		String imagePath = RunConfiguration.getProjectDir() + "/Captcha/captcha.png";
		String captcha = instance.doOCR(new File(imagePath));
		KeywordUtil.logInfo("Captcha : " + captcha)
		WebUI.closeBrowser();
	}
}